UNIT g256;

INTERFACE
{}  uses crt;
  procedure init256;
  procedure close256;
  procedure SetActivePage(page : integer);
  procedure SetVisualPage(page : integer);
  procedure cls;
  procedure show_window(XBegin,YBegin,Size : word;color : byte);
  procedure putpixel256(x,y : integer;c : byte);
  function getpixel256(x,y : integer) : word;
  procedure Bar256(x1, y1, x2, y2, color : integer);
  procedure line256(x1,y1,x2,y2 : integer; c : byte);
  function floodfill256(SeedX,SeedY,d,PrevXR,PrevXL : integer) : integer;
  procedure setpalette256;
  procedure SetGrayPalette;
  procedure InitPalette;
  procedure start(x,y : integer);
  var
    Color,BorderColor,FillColor : byte;{६  ࠭ ᮮ. 梥⮢}
    Palette : array [0..255,1..3] of byte;
    CenterX,CenterY : word;

IMPLEMENTATION
  CONST
{    Addr=$0a000;}
    EGA_GRAPHICS         =$03CE; {Graphics Controoler base addr}
    EGA_SEQUENCER        =$03C4; {sequencer base addr}
    EGA_CRTC             =$03D4;
    EGA_SET_RESET        =0;
    EGA_ENABLE_SET_RESET =1;
    EGA_COLOR_COMPARE    =2;
    EGA_DATA_ROTATE      =3;
    EGA_READ_MAP_SELECT  =4;
    EGA_MODE             =5;
    EGA_MISC             =6;
    EGA_COLOR_DONT_CARE  =7;
    EGA_BIT_MASK         =8;
    EGA_MAP_MASK         =2;

  VAR
    HistoryMode : byte;
    PageBase : word;

{  ॣ}
procedure WriteReg(base, reg, value : integer);
begin
  port[base]:=reg;
  port[base+1]:=value
end;

{⥭  ॣ}
function ReadReg(base, reg : integer) : byte;
begin
  port[base]:=reg;
  ReadReg:=port[base+1]
end;

procedure init256;
begin
  asm
    mov ah,0fh
    int 10h
    mov HistoryMode,al
    mov ah,0
    mov al,13h
    int 10h
  end;
  PageBase:=$0a000;
  WriteReg(EGA_SEQUENCER, 4, 6);
  WriteReg(EGA_CRTC, $17, $E3);
  WriteReg(EGA_CRTC, $14, 0);
  {clear screen}
  WriteReg(EGA_SEQUENCER, EGA_MAP_MASK, $F);
  cls;
end;

procedure close256;
begin
  asm
    mov ah,0
    mov al,HistoryMode
    int 10h
  end
end;

procedure SetVisualPage(page : integer);
var
  addr : word;
begin
  addr:=page*$4000;
  while (port[$03DA] and 8)=0 do;  {wait for vertical retrace}
  WriteReg(EGA_CRTC, $0C, addr div 256);
  WriteReg(EGA_CRTC, $DC, addr and $0F);
end;

procedure SetActivePage(page : integer);
begin
  PageBase:=$A000+page*$400;
end;

procedure putpixel256;
begin
{  mem[$a000:(y*320+x)]:=c}
  WriteReg(EGA_SEQUENCER, EGA_MAP_MASK, 1 shl (x and 3));
{  port[EGA_SEQUENCER]:=EGA_MAP_MASK;
  port[EGA_SEQUENCER+1]:=1 shl (x and 3);}
  mem[PageBase:(y*80 + x div 4)]:=c;
  WriteReg(EGA_SEQUENCER, EGA_MAP_MASK, $0F)
{  port[EGA_SEQUENCER]:=EGA_MAP_MASK;
  port[EGA_SEQUENCER+1]:=$0F;}
end;

function getpixel256;
begin
end;

procedure Bar256(x1, y1, x2, y2, color : integer);
var
  vptr : ^byte;
  y,x, cols : integer;
  lmask, rmask : byte;
begin
  vptr:=ptr(PageBase,y1*80+(x1 shr 4));
  cols:=(x2 div 4) - (x1 div 4) - 1;
  lmask:=$FF shr ((x1 and 3) and 7);
  rmask:=$FF shl (7 or ((x2 and 3) and 7));
  if cols<0 then begin
    WriteReg(EGA_SEQUENCER, EGA_MAP_MASK, lmask and rmask);
    for y:=y1 to y2 do begin
      vptr^:=color;
      vptr:=pointer(longint(vptr)+80)
    end;
    WriteReg(EGA_SEQUENCER, EGA_MAP_MASK, $0F);
  end else begin
    WriteReg(EGA_SEQUENCER, EGA_MAP_MASK, lmask);
    for y:=y1 to y2 do begin
      vptr^:=color;
      vptr:=pointer(longint(vptr)+80)
    end;
    WriteReg(EGA_SEQUENCER, EGA_MAP_MASK, $0F);
    vptr:=ptr(PageBase,y1*80+(x1 shr 4)+1);
    for y:=y1 to y2 do begin
      for x:=0 to cols-1 do begin
        vptr^:=color;
        inc(vptr)
      end;
      vptr:=pointer(longint(vptr)+80-cols)
    end;
    vptr:=ptr(PageBase,y1*80+(x1 shr 4)+1+cols);
    for y:=y1 to y2 do begin
      vptr^:=color;
      vptr:=pointer(longint(vptr)+80)
    end;
  end;
  WriteReg(EGA_SEQUENCER, EGA_MAP_MASK, $0F);

end;

procedure line256;
var
  dxx,dy,sx,sy,d,d1,d2,x,y,i,m1,m2 : integer;
begin
{}
  x1:=x1{+CenterX}; x2:=x2{+CenterX};
  y1:={CenterY-}y1; y2:={CenterY-}y2;
{}
  dxx:=abs(x2-x1);  dy:=abs(y2-y1);
  if x2<x1 then sx:=-1 else sx:=1;
  if y2<y1 then sy:=-1 else sy:=1;
  if dy<=dxx then begin
{    d:=2*dy-dxx;  d1:=dy*2;  d2:=(dy-dxx)*2;}
    asm
      mov ax,dy;    sal ax,1;    mov d1,ax;
      sub ax,dxx;   mov d,ax;
      sub ax,dxx;   mov d2,ax;
    end;
    x:=x1;  y:=y1;
    for i:=0 to dxx do begin
        mem[$a000:(y*320+x)]:=c;  {putpixel256(x,y,c);}
      if d>0 then begin
        d:=d+d2;
        y:=y+sy;
      end
      else d:=d+d1;
      x:=x+sx;
    end;
  end
  else begin
{    d:=2*dxx-dy;    d1:=dxx*2;  d2:=(dxx-dy)*2;}
    asm
      mov ax,dxx;   sal ax,1;    mov d1,ax;
      sub ax,dy;    mov d,ax;
      sub ax,dy;    mov d2,ax;
    end;
    x:=x1; y:=y1;
    for i:=0 to dy do begin
      mem[$a000:(y*320+x)]:=c;  {putpixel256(x,y,c);}
      if d>0 then begin
        d:=d+d2;
        x:=x+sx;
      end
      else d:=d+d1;
      y:=y+sy
    end
  end
end;

procedure cls;
{label l01,l02,l03,l04,l05;}
var i,j,k : integer;
begin
{  for j:=0 to 199 do begin
    k:=j*320;
    for i:=0 to 80 do
      meml[$a000:k+i*4]:=0;
  end;}
  for j:=0 to 199 do begin
    for i:=0 to 320 do
      putpixel256(i,j,0);
  end;
{  asm
    cld
    mov ax,0a000h
    mov es,ax
    mov di,0
    mov ax,0
    mov cx,32768
    rep stosw
  end;     }
{  asm
    mov ax,0a000h
    mov es,ax
    mov bx,63988
    xor ax,ax
@1:
    mov word ptr es:[bx],ax
    dec bx; dec bx
    ja @1
  end}
end;

{㥬  襭  梥⮬}
procedure show_window(XBegin,YBegin,Size : word;color : byte);
var i,j,k : integer;
begin
  for j:=YBegin to YBegin+Size-1 do begin
    k:=j*320;
    for i:=XBegin to XBegin+Size-1 do
      mem[$a000:k+i]:=color;
  end;
end;

procedure ScanLeft(var x,y : integer);
var v : integer;
begin
  repeat
    dec(x);
    v:=mem[$a000:y*320+x];
  until (v=BorderColor)or(v=Fillcolor)or(x<0);
  inc(x);
end;

procedure ScanRight(var x,y : integer);
var v : integer;
begin
  repeat
    inc(x);
    v:=mem[$a000:y*320+x];
  until (v=BorderColor)or(v=Fillcolor)or(x>319);
  dec(x);
end;

function FloodFill256;
var
  x,y,xl,xr,v : integer;
begin
{delay(10);}
  y:=SeedY;  xl:=SeedX;  xr:=SeedX;
  ScanLeft(xl,y);   ScanRight(xr,y);
  Line256(xl,y,xr,y,FillColor);
  x:=xl-1;
  while x<=xr do begin
    inc(x);
    v:=mem[$a000:(y+d)*320+x];
    if (v<>BorderColor)and(v<>FillColor) then
      x:=FloodFill256(x,y+d,d,xl,xr);
  end;

  x:=xl-1;
  while x<PrevXL do begin
    inc(x);
    v:=mem[$a000:(y-d)*320+x];
    if (v<>BorderColor)and(v<>FillColor) then
      x:=FloodFill256(x,y-d,-d,xl,xr);
  end;

  x:=PrevXR-1;
  while x<xr do begin
    inc(x);
    v:=mem[$a000:(y-d)*320+x];
    if (v<>BorderColor)and(v<>FillColor) then
      x:=FloodFill256(x,y-d,-d,xl,xr);
  end;
end;

procedure fill(SeedX,SeedY : integer);
begin
  asm
    push 321;
    push SeedX{ax}; push SeedX{bx}; push 1{cx}; push SeedX{dx}; push SeedX{si};

@Loop:
    pop ax      { न Prev }
    cmp ax,321
    je @Exit
@LineAdjFill:
    pop bx; pop cx;  pop dx;  pop si;
{ScanLeft}
{ScanRight}
    jmp @Loop
@Exit:
  end;
end;

procedure start;
var i : integer;
begin
{  i:=floodfill256(x,y,1,x,x);}
  fill(x,y);
end;

{⠭ ⨢  ࠭  ᨢ Palette}
procedure setpalette256;
begin
  asm
    push ds
    pop es
    mov dx,offset Palette   {⠭.  ⠡ 梥⮢ - ᨢ Palette}
    mov ax,1012h
    mov bx,0
    mov cx,256
    int 10h
  end
end;

procedure SetGrayPalette;
begin
  asm
    mov ax,101bh
    mov bx,0
    mov cx,256
    int 10h
  end
end;

procedure InitPalette;
var i : byte;
begin
  for i:=0 to 63 do begin
    Palette[i,1]:=i; Palette[i,2]:=i; Palette[i,3]:=i
  end;
{  for i:=64 to 255 do begin
    Palette[i,1]:=1; Palette[i,2]:=1; Palette[i,3]:=1
  end;}
  setpalette256
end;

BEGIN
  CenterX:=160; CenterY:=100;
END.