UNIT object3d;

INTERFACE

  USES g256, tools, vectors, {}crt;

  TYPE
    PPoly = ^Poly;
    PBody = ^Body;
    PLightSource = ^LightSource;
    PPointLight = ^PointLight;
    Medium = record
      nRefr, Betta : double; {. ५  饭}
    end;
    SurfaceData = record
      { 䮭, 㧭, ઠ쭮, ࠦ
       ५ ᢥ饭⥩}
      Ka, Kd, Ks, Kr, Kt : double;
      Med : Medium;
      Color : Vector;  {梥}
      N : Vector; {ଠ}
      p : integer;   {⥯ - . }
    end;
    LightSource = object  {ࠪ 筨 ᢥ}
      Color : Vector;
      constructor Init;
      destructor Done; virtual;
      function Shadow(PVect, LVect : PVector; PPol : PPoly) : double; virtual;
      procedure SetColor(Cx, Cy, Cz : double);
    end;
    Poly = object      { ࠭ 㣮}
      PoList : TList; {ᯨ᮪ 設}
      Colors : array [1..3] of Vector; {color of }
{      p1,p2,p3 : PPoint;  } {㪠⥫  ᮮ. ᯨ᪨  ᯨ᪠ 設}
      Color : Vector; {- 設  梥 }
      visible : boolean; {ਧ }
      a,b,c,d : double; {樥 ࠢ ᪮, 饩 .}
{      NVector : TPoint; } {樥 ᪮}
      XMin,XMax,YMin,YMax,ZMin,ZMax : double;  { אַ㣮쭮 ꥬ饩 窨 .}
      pb : pbody;  {㪠⥫  ⥫,  - ⭮ ࠭}

      Material : SurfaceData;
      constructor Init(AColor : Vector);
      procedure AddPoint(NumPoint : word);
      procedure DefinePoly;
      procedure DefineVisible;
      procedure DefineEges;
      procedure SetMaterial(Ia, Id, Is, Ir, It : double; Ip : integer);
{      procedure DefineFlat; }{८। ᪮ 饩 㣮쭨}
    end;
    Body = object
      Center : TPoint;    {न 業 ⥫  . 쥪⮢,}
                          {⭮ -  ந ८ࠧ}
      FirstPoly : word; {㪠⥫  1- ࠭  饬 ᯨ᪥ ࠭}
      Number : word; {- ࠭  ⥫}

      constructor Init(x,y,z : double);
      procedure SetBody(First,Numb : word);
      destructor Done;

      procedure AxisRotation(angle,typerot : word);{  . }
    end;
    PointLight = object(LightSource)
      Loc : TPoint;
      DistScale : double;
      function Shadow(PVect, LVect : PVector; PPol : PPoly) : double; virtual;
      procedure SetLocation(Ix, Iy, Iz : double);
      procedure SetScale(IScale : double);
      procedure Move(Dx, Dy, Dz : double);
    end;

  procedure AddPoint(x,y,z : double);  {塞   ᯨ᮪ 祪}

  procedure SetPosition(x,y,z : double);
  procedure GetPosition(var x,y,z : double);
  procedure SetCamera(CamA, CamB : double);
  procedure GetCamera(var CamA, CamB : double);
  procedure Proectiv(p : PPoint);
  procedure ProectivAll;
  procedure RotationX(p : PPoint);
  procedure RotationY(p : PPoint);
  procedure RotationZ(p : PPoint);
{  procedure RotationBody(pb : PBody; angle,typerot : word);}
  procedure DrawAll;
  procedure DefineAllStatus;
  procedure ZString(page : integer);
  function Shade(p : PVector; Pol : PPoly) : PVector;

  const
    rad=pi/360;
  var
    CameraP : TPoint;
    CameraA, CameraB : double;
{    matr,Displac,Speed : array[1..4,1..4] of double;}
    f,sinf,cosf : double;
{    Scale : integer;}

{    NumberPoly : word;} {᫮ 㣮쭨  業}
{    Stac : array [1..100,1..3] of word;}  {⥪  ࠭ }

    Lights, Bodys, Polys, Points : TList;{ᯨ᪨ ᢥ, ⥫, ࠭, 祪}

    Ambient : Vector;
    Threshold : double;  {䨫    筨}
    ViewPoint, ViewDir : Vector; {窠   }
    cosy,siny,cosx,sinx : double;

IMPLEMENTATION

{LightSource}
constructor LightSource.Init;
begin
  Color.X:=1;  Color.Y:=1;  Color.Z:=1;
  Lights.Add(@Self)
end;

destructor LightSource.Done;
begin
end;

function LightSource.Shadow(PVect, LVect : PVector; PPol : PPoly) : double;
begin
  Shadow:=0
end;

procedure LightSource.SetColor;
begin
  Color.X:=Cx;   Color.Y:=Cy;  Color.Z:=Cz;
end;
{}

{PointLight}
function PointLight.Shadow(PVect, LVect : PVector; PPol : PPoly) : double;
var
  Dist, Attenuation : double;
  i, ii, j, jj : integer;
  pp : PPoly;
  a, b, t, k : double;
  Cross, Cross1 : Vector;
  p1, p2 : PPoint;
begin
  LVect^.X:=Loc.X1-PVect^.X;
  LVect^.Y:=Loc.Y1-PVect^.Y;
  LVect^.Z:=Loc.Z1-PVect^.Z;
{।塞  ᢥ   ࠭,  ⮣ 㣮 }
{ ଠ ࠭  ࠢ 筨   }
  if (PPol^.a*LVect^.X+PPol^.b*LVect^.y+PPol^.c*LVect^.Z)<0 then begin
    Shadow:=0;
    exit
  end;
  with LVect^ do begin
    Dist:=sqrt(X*X+Y*Y+Z*Z);
    if Dist<>0 then begin
      X:=X/Dist;  Y:=Y/Dist;  Z:=Z/Dist;  {ଠ㥬 }
      Attenuation:=DistScale/Dist;   {।塞 樥 । ᢥ}
    end;
  end;
  Attenuation:=Attenuation*Attenuation;
{!!! ⪫砥 ⥭}
  Shadow:=Attenuation;
  exit;
{!!!!}
{ 室 ஢ઠ  ⥭ 㣨 ꥪ⠬}
  for i:=1 to Polys.Count do begin
    pp:=Polys.Items(i);
    {࠭ ᠬ ᥡ  ⥭}
    if (pp=PPol){ or (not pp^.Visible)} then continue;
    a:=pp^.a*LVect^.X+pp^.b*LVect^.Y+pp^.c*LVect^.Z;
    if a=0 then continue;  { ࠫ ᪮}
    b:=-(pp^.a*PVect^.X+pp^.b*PVect^.Y+pp^.c*PVect^.Z+pp^.d);
{??}if b=0 then continue;
{??}t:=b/a{a/b};
    if (t<0) or (t>Dist) then continue;
    Cross.X:=PVect^.X+LVect^.X*t;
    Cross.Y:=PVect^.Y+LVect^.Y*t;
    Cross.Z:=PVect^.Z+LVect^.Z*t;
{।塞   窠 祭    ࠭}
    if (pp^.ZMax>Cross.Z) and (pp^.ZMin>Cross.Z) then continue;
    if (pp^.ZMax<Cross.Z) and (pp^.ZMin<Cross.Z) then continue;
    if (pp^.XMax>Cross.X) and (pp^.XMin>Cross.X) then continue;
    if (pp^.XMax<Cross.X) and (pp^.XMin<Cross.X) then continue;
    if (pp^.YMax>Cross.Y) and (pp^.YMin>Cross.Y) then continue;
    if (pp^.YMax<Cross.Y) and (pp^.YMin<Cross.Y) then continue;
    {।塞 १ 祭 ࠭  אַ}
    ii:=0;
    for j:=1 to pp^.PoList.Count do begin
      jj:=j+1;
      if jj>pp^.PoList.Count then jj:=1;
      p1:=pp^.PoList.Store^[j];
      p2:=pp^.PoList.Store^[jj];
      if (p1^.y1>Cross.Y) and (p2^.y1>Cross.Y) then continue;
      if (p1^.y1<Cross.Y) and (p2^.y1<Cross.Y) then continue;
      if p1^.y1=p2^.y1 then continue;
{}
      k:=(Cross.Y-p1^.y1)/(p2^.y1-p1^.y1);
      if (k*(p2^.x1-p1^.x1)+p1^.x1>=Cross.X) then inc(ii);
    end;
    if ii mod 2=1 then begin
      Shadow:=0;
      exit
    end;
  end;
{}
  Shadow:=Attenuation
end;

procedure PointLight.SetLocation;
begin
  Loc.X:=Ix;  Loc.Y:=Iy;  Loc.Z:=Iz
end;

procedure PointLight.SetScale;
begin
  DistScale:=IScale
end;

procedure PointLight.Move;
begin
  Loc.X:=Loc.X+Dx;  Loc.Y:=Loc.Y+Dy;  Loc.Z:=Loc.Z+Dz
end;
{}

{⮤ ࠭}
constructor Poly.Init(AColor : Vector);
begin
  Polys.Add(@Self); {塞 ࠭  ᯨ᮪ ࠭}
  PoList.InitList;
  PoList.SetExpSize(1);  {  }
  Color:=AColor
end;

procedure Poly.AddPoint;
begin
  PoList.Add(Points.Items(NumPoint));
end;

procedure Poly.DefineVisible;
var
  i : word;
  k : double;
  p : array [1..3] of PPoint;
{  a1, a2, a3, b1, b2, b3 : double;}
begin
  for i:=1 to 3 do
    p[i]:=PoList.Store^[i];

{  a1:=p[2]^.x1-p[1]^.x1; a2:=p[2]^.y1-p[1]^.y1; a3:=p[2]^.z1-p[1]^.z1;
  b1:=p[3]^.x1-p[1]^.x1; b2:=p[3]^.y1-p[1]^.y1; b3:=p[3]^.z1-p[1]^.z1;
  a:=a2*b3-a3*b2;
  b:=a3*b1-a1*b3;
  c:=a1*b2-a2*b1;
  d:=-p[1]^.y1*b-p[1]^.x1*a-p[1]^.z1*c;}

  a:=(p[2]^.y1-p[1]^.y1)*(p[3]^.z1-p[1]^.z1)-(p[2]^.z1-p[1]^.z1)*(p[3]^.y1-p[1]^.y1);
  b:=(p[2]^.z1-p[1]^.z1)*(p[3]^.x1-p[1]^.x1)-(p[2]^.x1-p[1]^.x1)*(p[3]^.z1-p[1]^.z1);
  c:=(p[2]^.x1-p[1]^.x1)*(p[3]^.y1-p[1]^.y1)-(p[2]^.y1-p[1]^.y1)*(p[3]^.x1-p[1]^.x1);
  d:=-p[1]^.y1*b-p[1]^.x1*a-p[1]^.z1*c;
{ନ㥬 ଠ}
  k:=sqrt(a*a+b*b+c*c);
  if k<>0 then begin
    a:=a/k; b:=b/k; c:=c/k; d:=d/k
  end;
{஥஢ ଠ  । . D  ࠢ ᪮}
{  Proectiv(@NVector);
  d:=-PPoint(PoList.Store^[1])^.x1*NVector.X1-
      PPoint(PoList.Store^[1])^.y1*NVector.Y1-
      PPoint(PoList.Store^[1])^.z1*NVector.Z1;}
{祭 楢 ࠭}
  if c{NVector.Z1}<=0 then Visible:=true else Visible:=false;
{।塞 ꥬ }
  XMax:=p[1]^.x1;  XMin:=XMax;
  YMax:=p[1]^.y1;  YMin:=YMax;
  ZMax:=p[1]^.z1;  ZMin:=ZMax;
  for i:=2 to PoList.Count do begin
    p[2]:=PoList.Store^[i];
    if XMax<p[2]^.x1 then XMax:=p[2]^.x1;
    if XMin>p[2]^.x1 then XMin:=p[2]^.x1;
    if YMax<p[2]^.y1 then YMax:=p[2]^.y1;
    if YMin>p[2]^.y1 then YMin:=p[2]^.y1;
    if ZMax<p[2]^.z1 then ZMax:=p[2]^.z1;
    if ZMin>p[2]^.z1 then ZMin:=p[2]^.z1;
  end;
end;

{।  ࠭ ଠ쭮 }
{室  樠樨 ࠭ ???  筥  न}
{procedure Poly.DefineFlat;
var
  i : word;
  k : double;
  p : array [1..3] of PPoint;
begin
  for i:=1 to 3 do
    p[i]:=PoList.Store^[i];
  NVector.X:=(p[2]^.y-p[1]^.y)*(p[3]^.z-p[1]^.z)-(p[2]^.z-p[1]^.z)*(p[3]^.y-p[1]^.y);
  NVector.Y:=(p[2]^.z-p[1]^.z)*(p[3]^.x-p[1]^.x)-(p[2]^.x-p[1]^.x)*(p[3]^.z-p[1]^.z);
  NVector.Z:=(p[2]^.x-p[1]^.x)*(p[3]^.y-p[1]^.y)-(p[2]^.y-p[1]^.y)*(p[3]^.x-p[1]^.x);
  with NVector do begin}  {ନ㥬 }
{    k:=sqrt(x*x+y*y+y*y);
    if k<>0 then begin
      x:=x/k; y:=y/k; z:=z/k
    end;
  end;
end;}

{।塞 ᢥ饭  㣫 ࠭}
procedure Poly.DefineEges;
var
  i : integer;
begin
  for i:=1 to 3 do begin
    Colors[1]:=Shade(PVector(PoList.Items(i)), @Self)^;
  end;
end;

procedure Poly.DefinePoly;
begin
end;

procedure Poly.SetMaterial;
begin
  Material.Ka:=Ia;  Material.Kd:=Id;  Material.Ks:=Is;
  Material.Kr:=Ir;  Material.Kt:=It;  Material.P:=Ip
end;
{ ⮤ ࠭}

{⮤ ꥪ Body}
constructor Body.Init(x,y,z : double);
begin
  Bodys.Add(@Self);  {頥 ⥫  ᯨ᮪ ⥫}
  Center.X:=x;  Center.Y:=y; Center.Z:=z
end;

procedure Body.SetBody(First,Numb : word);
var
  i : integer;
begin
  FirstPoly:=First; Number:=Numb;
{樠 ᪮⥩}
{  for i:=FirstPoly to FirstPoly+Number-1 do
    PPoly(Polys.Items(i))^.DefineFlat;}
end;

destructor Body.Done;
begin
end;

procedure Body.AxisRotation(angle,typerot : word);
var
  i,j : integer;
  p : PPoint;
  pl : PPoly;
  TempList : TList;
begin
  TempList.InitList; TempList.SetExpSize(10);
  f:=angle*rad; sinf:=sin(f); cosf:=cos(f);
  for i:=1 to Number do begin  {  ࠭}
    pl:=Polys.Items(FirstPoly+Number-1);
    for j:=1 to pl^.PoList.Count do begin
      p:=pl^.PoList.Store^[j];  {६  ࠭}
      if TempList.IndexOf(p)=0 then begin
        case typerot of
          1{x}: RotationX(p);
          2{y}: RotationY(p);
          3{z}: RotationZ(p);
        end;
        TempList.Add(p)
      end;
    end;
{    case typerot of
      1: RotationX(@(pl^.NVector));
      2: RotationY(@(pl^.NVector));
      3: RotationZ(@(pl^.NVector));
    end;}
  end;
  TempList.Clear;
end;
{ ⮤ ꥪ Body}

{省   ᯨ᮪ 祪}
procedure AddPoint(x,y,z : double);
var p : PPoint;
begin
  new(p);
  p^.x:=x; p^.y:=y; p^.z:=z;
  Points.Add(p)
end;

{   ࠭⢥}
procedure SetPosition(x,y,z : double);
begin
  CameraP.X:=x;  CameraP.Y:=y; CameraP.Z:=z;
end;

procedure GetPosition(var x,y,z : double);
begin
  x:=CameraP.X;  y:=CameraP.Y; z:=CameraP.Z;
end;

procedure SetCamera(CamA, CamB : double);
begin
{窠  ⠥ ⮩  => 0,0,0 }
  CameraA:=CamA;  CameraB:=CamB;
  cosy:=cos(CameraA*Pi/180);  siny:=sin(CameraA*Pi/180);
  cosx:=cos(CameraB*Pi/180);  sinx:=sin(CameraB*Pi/180);
{  cosy:=1/sqrt(2); siny:=cosy;  cosx:=sqrt(2/3); sinx:=1/sqrt(3);}
end;

procedure GetCamera(var CamA, CamB : double);
begin
  CamA:=CameraA;  CamB:=CameraB
end;

procedure Proectiv;
{var
  t : double;}
begin
  with p^ do begin
    x1:=(x-CameraP.X)*cosy-(y-CameraP.Y)*sinx*siny+(z-CameraP.Z)*siny*cosx;
    y1:=(y-CameraP.Y)*cosx+(z-CameraP.Z)*sinx;
    z1:=-(x-CameraP.X)*siny-(y-CameraP.Y)*cosy*sinx+(z-CameraP.Z)*cosy*cosx;
{    t:=z1/(100-z1);
    x1:=x1*t+x1;
    y1:=y1*t+y1;
    z1:=0;}
{    x1:=x1+CenterX;
    y1:=CenterY-y1;}

{    x1:=x*cosy+y*sinx*siny+z*siny*cosx;
    y1:=y*cosx+z*sinx;
    z1:=x*sinx-y*cosy*sinx+z*cosy*cosx;
    x1:=x1+CenterX;
    y1:=CenterY-y1;}
  end;
end;

procedure ProectivAll;
var i : word;
begin
  for i:=1 to Points.Count do  {窨 ࠭}
    Proectiv(Points.Items(i));
  for i:=1 to Lights.Count do  {筨 ᢥ}
    Proectiv(@(PPointLight(Lights.Items(i))^.Loc))
end;

procedure RotationX(p : PPoint); {f, cosf, sinf - । । ⨬}
var y2,z2 : double;
begin
  with p^ do begin
    y2:=y*cosf+z*sinf;
    z2:=-y*sinf+z*cosf;
    y:=y2; z:=z2;
  end;
end;

procedure RotationY(p : PPoint); {f, cosf, sinf - । । ⨬}
var x2,z2 : double;
begin
  with p^ do begin
    x2:=x*cosf-z*sinf;
    z2:=x*sinf+z*cosf;
    x:=x2; z:=z2;
  end;
end;

procedure RotationZ(p : PPoint); {f, cosf, sinf - । । ⨬}
var x2,y2 : double;
begin
  with p^ do begin
    x2:=x*cosf+y*sinf;
    y2:=-x*sinf+y*cosf;
    y:=y2; x:=x2;
  end;
end;

procedure RotationBody(pb : PBody; angle,typerot : word);
var
  i : integer;
  p : PPoint;          { }
begin
  f:=angle*rad; sinf:=sin(f); cosf:=cos(f);
  for i:=1 to Points.Count do
    case typerot of
      1{x}: RotationX(Points.Items(i));
      2{y}: RotationY(Points.Items(i));
      3{z}: RotationZ(Points.Items(i));
    end;
end;

procedure DrawAll;
var
  i,j : word;
  pp : PPoly;
  p1, p2 : PPoint;
begin
  for i:=1 to Polys.GetCount do begin
    pp:=Polys.Items(i);        {६ ᫥. ࠭}
    with pp^ do
      if Visible then begin
        for j:=1 to PoList.Count-1 do begin
          p1:=PoList.Store^[j];
          p2:=PoList.Store^[j+1];
          line256(round(p1^.x1),round(p1^.y1),round(p2^.x1),round(p2^.y1),15);
        end;
        p1:=PoList.Store^[1];
        line256(round(p1^.x1),round(p1^.y1),round(p2^.x1),round(p2^.y1),15);
      end;
  end;
end;

{। 楢 ࠭}
procedure DefineAllStatus;
var
  i : word;
{  p : PPoly;}
begin
  for i:=1 to Polys.Count do begin   {६ ᫥. ࠭}
{    p:=Polys.Items(i);
    p^.DefineVisible;
    if p^.Visible then p^.DefineEges;}
    PPoly(Polys.Items(i))^.DefineVisible;
    if PPoly(Polys.Items(i))^.Visible then PPoly(Polys.Items(i))^.DefineEges;
  end;
end;

{뢮 ࠦ  Z-஬}
procedure ZString;
var
  y,x,i,j,ii,jj,xbeg,xend : integer;
  z,k : double;
  pp : PPoly;
  XCross : array [1..2] of double;
  p1, p2 : PPoint;
  ZBuff : array [0..319] of double;
  ZBuffPoly : array [0..319] of PPoly;
  p : Vector;
  Color : PVector;
{}  test : integer;
  speed1, speed2 : double; {help variable for more speed}
  PageBase : longint;
begin
  PageBase:=$A000+page*$400;
  for x:=0 to 319 do ZBuff[x]:=99999;
  for y:=0 to 199 do begin
    for i:=1 to Polys.Count do begin
      pp:=Polys.Items(i);        {६ ᫥. ࠭}
      if (pp^.Visible) and (y>=pp^.YMin) and (y<=pp^.YMax) and
      ((pp^.XMax>0{<319}) or (pp^.XMin<319{>0})) then begin
        {।塞 १ 祭 ࠭  אַ}
        ii:=1;
{}
        p1:=pp^.PoList.Store^[pp^.PoList.Count];
        for j:=1 to pp^.PoList.Count do begin
          p2:=pp^.PoList.Store^[j];
{஢ન   祭 אַ  ஥樥 ࠭}
          if ((p1^.y1>y) and (p2^.y1>y)) then begin
            p1:=p2;
            continue;
          end;
          if (p1^.y1<y) and (p2^.y1<y) then begin
            p1:=p2;
            continue;
          end;
          if p1^.y1=p2^.y1 then begin
            {᫨ १ "ਧ⠫",  ६  ࠩ 窨}
            XCross[1]:=p1^.x1; XCross[2]:=p2^.x1;
            ii:=3;
            break;
          end;
{}
          XCross[ii]:=(y-p1^.y1)*(p2^.x1-p1^.x1)/(p2^.y1-p1^.y1)+p1^.x1;
          if ii=2 then begin
{஢塞  ᮢ  祭  窨}
{砩 祭 ᪠饩 אַ  設 ࠭}
            if XCross[1]<>XCross[2] then begin
              ii:=3;
              break;
            end;
          end else inc(ii);
          p1:=p2;
        end; {for}
        if (ii=3) and (pp^.c<>0) then begin
          xbeg:=round(XCross[1]);
          xend:=round(XCross[2]);
          if xbeg>xend then begin
            jj:=xbeg;  xbeg:=xend; xend:=jj
          end;
{}
          if xbeg<0 then xbeg:=0;
          if xend>319 then xend:=319;
{}
          speed1:=pp^.a/pp^.c;
          speed2:=(pp^.b*y+pp^.d)/pp^.c;
          for x:=xbeg to xend do begin
            {z:=-(pp^.a*x+pp^.b*y+pp^.d)/pp^.c;}
            z:=-speed1*x-speed2;
            if (z<ZBuff[x]) and (z>0) then begin
              ZBuff[x]:=z;
              ZBuffPoly[x]:=pp;
            end;
          end;
        end;
      end;
    end;
    p.y:=y;
    test:=y*80;
    for x:=0 to 319 do
      if ZBuff[x]<99999 then begin
        p.x:=x; p.z:=ZBuff[x];
        Color:=Shade(@p,ZBuffPoly[x]);
        if Color^.X>63 then Color^.X:=63;
{        PutPixel256(x,y,round(color^.x));}
        port[$03C4]:=2;
        port[$03C5]:=1 shl (x and 3);
        mem[PageBase:(test + x div 4)]:=round(color^.x);
{        port[$03C4]:=2;
        port[$03C4+1]:=$0F;}
        ZBuff[x]:=99999;  {ࠧ 頥 }
      end;
  end;
end;

{।塞 梥 窨  ࠭}
function Shade;
var
  Color : Vector;
  i : integer;
  k : double;
  Light : PLightSource;
  l : Vector; {ࠢ  筨 ᢥ}
  sh : double; {樥 ।  筨 ᢥ}
  Inv : double; {᪠୮ ந ஢ L  N}
  H : Vector; {  View and Light}
begin
{䮭 ᢥ饭}
  Color.X:=Pol^.Material.Ka*Ambient.X*Pol^.Color.X;
{אַ  筨 ᢥ}
  for i:=1 to Lights.Count do begin {室  筨}
    Light:=Lights.Items(i);
    sh:=Light^.Shadow(p,@l,Pol);  {।塞 ࠢ  筨  .}
    {᫨  筨 ⢥}
    if (sh>Threshold) then begin
      Inv:=l.X*Pol^.A+l.Y*Pol^.B+l.Z*Pol^.C;
      if Inv>Threshold then  begin
        {㧭 ࠦ}
        if Pol^.Material.Kd>Threshold then
          Color.X:=Color.X+(Pol^.Material.Kd*sh*Inv)*Light^.Color.X*Pol^.Color.X;
        if Pol^.Material.Ks>Threshold then begin
          H:=l;
          H.Z:=H.Z-1;  {View  न [0; 0; 1]}
          Normalize(@H);
          k:=H.X*pol^.a+H.Y*pol^.b+H.Z*pol^.c;  {᪠ - H  ଠ}
          Color.X:=Color.X+(Pol^.Material.Ks*Sh*exp(Pol^.Material.P*ln(k)))*Light^.Color.X
        end;
      end;
    end;
  end;
  Shade:=@Color
end;

BEGIN
  Lights.InitList;
  Bodys.InitList;
  Polys.InitList;
  Points.InitList;
{}
  ViewPoint.X:=0;
  ViewPoint.Y:=0;
  ViewPoint.Z:=-100;

  SetCamera(0,0); SetPosition(-160,-100,-500);
{  cosy:=1/sqrt(2); siny:=cosy;  cosx:=sqrt(2/3); sinx:=1/sqrt(3);}
{}
  Threshold:=0.1;
  Ambient.X:=20;  Ambient.Y:=0.5; Ambient.Z:=0.5;
END.